on startMovie
  global ScientistTotal, DataBaseEnter, QuizUp, NoQuiz, MovieIdentifier, Screen, NewFind
  cursor(4)
  set NewFind to 1
  HideScore()
  cursor(4)
  HideInfo()
  cursor(4)
  HideDBCopy()
  cursor(4)
  DatabaseScore()
  cursor(4)
  DatabaseInfo()
  cursor(4)
  DBCopyPrep()
  cursor(4)
  ClearTrackScripts()
  cursor(4)
  set ScientistTotal to 146
  BSetup(32, 39)
  BSuspend(4, 4)
  SoundControl()
  cursor(4)
  if DataBaseEnter = 0 then
    go("MainHelp")
    set the mouseUpScript to "LeaveMainHelp"
    set DataBaseEnter to 1
  end if
  cursor(4)
end

on ScientistChangeKey
  if charToNum(the key) = 28 then
    PrevScientist()
  end if
  if charToNum(the key) = 29 then
    NextScientist()
  end if
end

on IndexChangeKey
  if charToNum(the key) = 28 then
    PrevIndex()
  end if
  if charToNum(the key) = 29 then
    NextIndex()
  end if
end

on Index
  global Index
  cursor(4)
  repeat with count = 20 to 23
    set the puppet of sprite count to 0
  end repeat
  BSuspend(4, 4)
  BSuspend(8, 10)
  BSuspend(13, 13)
  set the castNum of sprite 32 to the number of member "Main.flat"
  set the castNum of sprite 33 to the number of member "Find.flat"
  set Index to "Main Screen"
  go("Main Screen")
  cursor(-1)
end

on NextScientist
  global ScientistTotal, ScientistNumber
  repeat with count = 20 to 23
    set the puppet of sprite count to 0
  end repeat
  set TempNum to ScientistNumber
  if the frame = (ScientistTotal + 60) then
    go(61)
  else
    go(the frame + 1)
  end if
  put EMPTY before line 1 of field (300 + TempNum)
  BSuspend(4, 4)
end

on PrevScientist
  global ScientistTotal, ScientistNumber
  repeat with count = 20 to 23
    set the puppet of sprite count to 0
  end repeat
  set TempNum to ScientistNumber
  if the frame = 61 then
    go(ScientistTotal + 60)
  else
    go(the frame - 1)
  end if
  put EMPTY before line 1 of field (300 + TempNum)
  BSuspend(4, 4)
end

on NextIndex
  global IndexTotal, IndexNumber
  if value(IndexNumber) = value(IndexTotal) then
    go(the frame - value(IndexTotal) + 1)
    set IndexNumber to 1
  else
    go(the frame + 1)
    set IndexNumber to value(IndexNumber) + 1
  end if
end

on PrevIndex
  global IndexTotal, IndexNumber
  if value(IndexNumber) = 1 then
    go(the frame + value(IndexTotal) - 1)
    set IndexNumber to IndexTotal
  else
    go(the frame - 1)
    set IndexNumber to value(IndexNumber) - 1
  end if
end

on idle
  global ButtonsActive, Section
  if ButtonsActive = 1 then
    CheckHilite(32, 39)
  end if
  CheckHilite(42, 43)
  CheckHilite(48, 48)
  SoundLoop()
  if Section <> "Find" then
    PopIdle()
  end if
end

on ExitMain
  set the castNum of sprite 32 to the number of member "BackDB.flat"
  BSuspend(8, 10)
  BSuspend(4, 4)
  repeat with count = 10 to 25
    set the puppet of sprite count to 0
  end repeat
end

on Find
  global Update, NewFind, OldLineNum, ManBold
  cursor(4)
  ExitMain()
  BHide(32, 32)
  if NewFind = 1 then
    set OldLineNum to 0
    set Update to 1
    set ManBold to 0
    set the hilite of cast "A-L" to 1
    set the hilite of cast "M-Z" to 0
    PrepFind()
    ResetFind()
    set NewFind to 0
  end if
  set the castNum of sprite 33 to the number of member "BackDB.flat"
  if Update = 1 then
    set the hilite of member "Yes" to 1
    set the hilite of member "No" to 0
  else
    set the hilite of member "Yes" to 0
    set the hilite of member "No" to 1
  end if
  set the keyUpScript to "FindUpdate"
  set the keyDownScript to "FindEnterWord"
  go("Find")
end

on ExitFind
  set the keyUpScript to EMPTY
  set the castNum of sprite 32 to the number of member "BackDB.flat"
  set the castNum of sprite 33 to the number of member "Find.flat"
  BSuspend(21, 22)
end

on ResetFind
  resetField(the number of member "Results", 12, "Plain", "Helvetica")
  set the textStyle of field "Words1" to "Plain"
  set the textStyle of field "Words2" to "Plain"
  set the scrollTop of member "Words1" to 0
  set the scrollTop of member "Words2" to 0
  resetField(the number of member "Entry", 12, "Plain", "Helvetica")
end

on IndexHilite
  global ButtonsActive
  if ButtonsActive = 0 then
    exit
  end if
  CheckHilite(11, 15)
  CheckHilite(21, 25)
  set MapHilite to 0
  repeat with count = 26 to 30
    if rollOver(count) = 1 then
      set MapHilite to 1
    end if
  end repeat
  if MapHilite = 1 then
    if (the castNum of sprite 10 mod 3) = 1 then
      set the castNum of sprite 10 to the castNum of sprite 10 + 1
    end if
    if the stillDown = 1 then
      if (the castNum of sprite 10 mod 3) = 2 then
        set the castNum of sprite 10 to the castNum of sprite 10 + 1
      end if
    else
      if (the castNum of sprite 10 mod 3) = 0 then
        set the castNum of sprite 10 to the castNum of sprite 10 - 1
      end if
    end if
  else
    if (the castNum of sprite 10 mod 3) = 2 then
      set the castNum of sprite 10 to the castNum of sprite 10 - 1
    end if
    if (the castNum of sprite 10 mod 3) = 0 then
      set the castNum of sprite 10 to the castNum of sprite 10 - 2
    end if
  end if
  repeat with loop = 26 to 30
    set count to loop - 10
    if rollOver(loop) = 1 then
      if (the castNum of sprite count mod 3) = 1 then
        set the castNum of sprite count to the castNum of sprite count + 1
      end if
      if the stillDown = 1 then
        if (the castNum of sprite count mod 3) = 2 then
          set the castNum of sprite count to the castNum of sprite count + 1
        end if
      else
        if (the castNum of sprite count mod 3) = 0 then
          set the castNum of sprite count to the castNum of sprite count - 1
        end if
      end if
      next repeat
    end if
    if (the castNum of sprite count mod 3) = 2 then
      set the castNum of sprite count to the castNum of sprite count - 1
    end if
    if (the castNum of sprite count mod 3) = 0 then
      set the castNum of sprite count to the castNum of sprite count - 2
    end if
  end repeat
end

on Back
  global Index, Section, ReturnPlace
  if the frame < 60 then
    if Section = "Find" then
      BShow(32, 33)
      ExitFind()
      if (Index = "Main Screen") or (Index = EMPTY) then
        Index()
      else
        go(ReturnPlace)
      end if
    else
      Index()
    end if
  else
    cursor(4)
    repeat with count = 20 to 23
      set the puppet of sprite count to 0
    end repeat
    BSuspend(4, 4)
    BSuspend(8, 10)
    BSuspend(13, 13)
    BShow(32, 33)
    set the castNum of sprite 32 to the number of member "BackDB.flat"
    set the castNum of sprite 33 to the number of member "Find.flat"
    cursor(-1)
    if (Index = "Main Screen") or (Index = EMPTY) then
      Index()
    else
      go(Index)
    end if
  end if
end

on Help
  if the frame < 5 then
    go("MainHelp")
  else
    if the frame < 55 then
      BSetup(2, 3)
      BSetup(8, 9)
      go("IndexHelp")
    else
      if the frame < 60 then
        beep()
      else
        beep()
      end if
    end if
  end if
end

on LeaveMainHelp
  cursor(4)
  ClearTrackScripts()
  puppetTempo(120)
  go("Main Screen")
  cursor(-1)
end

on LeaveIndexHelp
  ClearTrackScripts()
  BSuspend(2, 3)
  puppetTempo(120)
  Back()
end

on stopMovie
  put "   " into field "Index"
  set the soundEnabled to 1
  sound stop 2
end

on EnterIndex Num
  global Index, Section, DataBaseEnter, IndexTotal, IndexNumber
  set IndexNumber to 1
  set IndexTotal to Num
  put Index into field "Index"
  set Section to Index
  set the keyDownScript to "IndexChangeKey"
  if DataBaseEnter < 2 then
    BSetup(2, 3)
    BSetup(8, 9)
    go("IndexHelp")
    set DataBaseEnter to 2
  end if
end
